// Code generated by protoc-gen-micro. DO NOT EDIT.
// source: proto/configmap.proto

package kubernetes_service

import (
	fmt "fmt"
	proto "google.golang.org/protobuf/proto"
	math "math"
)

import (
	context "context"
	api "go-micro.dev/v4/api"
	client "go-micro.dev/v4/client"
	server "go-micro.dev/v4/server"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// Reference imports to suppress errors if they are not otherwise used.
var _ api.Endpoint
var _ context.Context
var _ client.Option
var _ server.Option

// Api Endpoints for ConfigMapService service

func NewConfigMapServiceEndpoints() []*api.Endpoint {
	return []*api.Endpoint{}
}

// Client API for ConfigMapService service

type ConfigMapService interface {
	GetConfigMapList(ctx context.Context, in *GetConfigMapListRequest, opts ...client.CallOption) (*GetConfigMapListResponse, error)
	GetConfigMap(ctx context.Context, in *GetConfigMapRequest, opts ...client.CallOption) (*GetConfigMapResponse, error)
	UpdateConfigMap(ctx context.Context, in *UpdateConfigMapRequest, opts ...client.CallOption) (*UpdateConfigMapResponse, error)
	CreateConfigMap(ctx context.Context, in *CreateConfigMapRequest, opts ...client.CallOption) (*CreateConfigMapResponse, error)
	DeleteConfigMap(ctx context.Context, in *DeleteConfigMapRequest, opts ...client.CallOption) (*DeleteConfigMapResponse, error)
}

type configMapService struct {
	c    client.Client
	name string
}

func NewConfigMapService(name string, c client.Client) ConfigMapService {
	return &configMapService{
		c:    c,
		name: name,
	}
}

func (c *configMapService) GetConfigMapList(ctx context.Context, in *GetConfigMapListRequest, opts ...client.CallOption) (*GetConfigMapListResponse, error) {
	req := c.c.NewRequest(c.name, "ConfigMapService.GetConfigMapList", in)
	out := new(GetConfigMapListResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *configMapService) GetConfigMap(ctx context.Context, in *GetConfigMapRequest, opts ...client.CallOption) (*GetConfigMapResponse, error) {
	req := c.c.NewRequest(c.name, "ConfigMapService.GetConfigMap", in)
	out := new(GetConfigMapResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *configMapService) UpdateConfigMap(ctx context.Context, in *UpdateConfigMapRequest, opts ...client.CallOption) (*UpdateConfigMapResponse, error) {
	req := c.c.NewRequest(c.name, "ConfigMapService.UpdateConfigMap", in)
	out := new(UpdateConfigMapResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *configMapService) CreateConfigMap(ctx context.Context, in *CreateConfigMapRequest, opts ...client.CallOption) (*CreateConfigMapResponse, error) {
	req := c.c.NewRequest(c.name, "ConfigMapService.CreateConfigMap", in)
	out := new(CreateConfigMapResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *configMapService) DeleteConfigMap(ctx context.Context, in *DeleteConfigMapRequest, opts ...client.CallOption) (*DeleteConfigMapResponse, error) {
	req := c.c.NewRequest(c.name, "ConfigMapService.DeleteConfigMap", in)
	out := new(DeleteConfigMapResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// Server API for ConfigMapService service

type ConfigMapServiceHandler interface {
	GetConfigMapList(context.Context, *GetConfigMapListRequest, *GetConfigMapListResponse) error
	GetConfigMap(context.Context, *GetConfigMapRequest, *GetConfigMapResponse) error
	UpdateConfigMap(context.Context, *UpdateConfigMapRequest, *UpdateConfigMapResponse) error
	CreateConfigMap(context.Context, *CreateConfigMapRequest, *CreateConfigMapResponse) error
	DeleteConfigMap(context.Context, *DeleteConfigMapRequest, *DeleteConfigMapResponse) error
}

func RegisterConfigMapServiceHandler(s server.Server, hdlr ConfigMapServiceHandler, opts ...server.HandlerOption) error {
	type configMapService interface {
		GetConfigMapList(ctx context.Context, in *GetConfigMapListRequest, out *GetConfigMapListResponse) error
		GetConfigMap(ctx context.Context, in *GetConfigMapRequest, out *GetConfigMapResponse) error
		UpdateConfigMap(ctx context.Context, in *UpdateConfigMapRequest, out *UpdateConfigMapResponse) error
		CreateConfigMap(ctx context.Context, in *CreateConfigMapRequest, out *CreateConfigMapResponse) error
		DeleteConfigMap(ctx context.Context, in *DeleteConfigMapRequest, out *DeleteConfigMapResponse) error
	}
	type ConfigMapService struct {
		configMapService
	}
	h := &configMapServiceHandler{hdlr}
	return s.Handle(s.NewHandler(&ConfigMapService{h}, opts...))
}

type configMapServiceHandler struct {
	ConfigMapServiceHandler
}

func (h *configMapServiceHandler) GetConfigMapList(ctx context.Context, in *GetConfigMapListRequest, out *GetConfigMapListResponse) error {
	return h.ConfigMapServiceHandler.GetConfigMapList(ctx, in, out)
}

func (h *configMapServiceHandler) GetConfigMap(ctx context.Context, in *GetConfigMapRequest, out *GetConfigMapResponse) error {
	return h.ConfigMapServiceHandler.GetConfigMap(ctx, in, out)
}

func (h *configMapServiceHandler) UpdateConfigMap(ctx context.Context, in *UpdateConfigMapRequest, out *UpdateConfigMapResponse) error {
	return h.ConfigMapServiceHandler.UpdateConfigMap(ctx, in, out)
}

func (h *configMapServiceHandler) CreateConfigMap(ctx context.Context, in *CreateConfigMapRequest, out *CreateConfigMapResponse) error {
	return h.ConfigMapServiceHandler.CreateConfigMap(ctx, in, out)
}

func (h *configMapServiceHandler) DeleteConfigMap(ctx context.Context, in *DeleteConfigMapRequest, out *DeleteConfigMapResponse) error {
	return h.ConfigMapServiceHandler.DeleteConfigMap(ctx, in, out)
}
