// Code generated by protoc-gen-micro. DO NOT EDIT.
// source: proto/daemonset.proto

package kubernetes_service

import (
	fmt "fmt"
	proto "google.golang.org/protobuf/proto"
	math "math"
)

import (
	context "context"
	api "go-micro.dev/v4/api"
	client "go-micro.dev/v4/client"
	server "go-micro.dev/v4/server"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// Reference imports to suppress errors if they are not otherwise used.
var _ api.Endpoint
var _ context.Context
var _ client.Option
var _ server.Option

// Api Endpoints for DaemonSetService service

func NewDaemonSetServiceEndpoints() []*api.Endpoint {
	return []*api.Endpoint{}
}

// Client API for DaemonSetService service

type DaemonSetService interface {
	GetDaemonSetList(ctx context.Context, in *GetDaemonSetListRequest, opts ...client.CallOption) (*GetDaemonSetListResponse, error)
	GetDaemonSet(ctx context.Context, in *GetDaemonSetRequest, opts ...client.CallOption) (*GetDaemonSetResponse, error)
	UpdateDaemonSet(ctx context.Context, in *UpdateDaemonSetRequest, opts ...client.CallOption) (*UpdateDaemonSetResponse, error)
	CreateDaemonSet(ctx context.Context, in *CreateDaemonSetRequest, opts ...client.CallOption) (*CreateDaemonSetResponse, error)
	DeleteDaemonSet(ctx context.Context, in *DeleteDaemonSetRequest, opts ...client.CallOption) (*DeleteDaemonSetResponse, error)
}

type daemonSetService struct {
	c    client.Client
	name string
}

func NewDaemonSetService(name string, c client.Client) DaemonSetService {
	return &daemonSetService{
		c:    c,
		name: name,
	}
}

func (c *daemonSetService) GetDaemonSetList(ctx context.Context, in *GetDaemonSetListRequest, opts ...client.CallOption) (*GetDaemonSetListResponse, error) {
	req := c.c.NewRequest(c.name, "DaemonSetService.GetDaemonSetList", in)
	out := new(GetDaemonSetListResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *daemonSetService) GetDaemonSet(ctx context.Context, in *GetDaemonSetRequest, opts ...client.CallOption) (*GetDaemonSetResponse, error) {
	req := c.c.NewRequest(c.name, "DaemonSetService.GetDaemonSet", in)
	out := new(GetDaemonSetResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *daemonSetService) UpdateDaemonSet(ctx context.Context, in *UpdateDaemonSetRequest, opts ...client.CallOption) (*UpdateDaemonSetResponse, error) {
	req := c.c.NewRequest(c.name, "DaemonSetService.UpdateDaemonSet", in)
	out := new(UpdateDaemonSetResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *daemonSetService) CreateDaemonSet(ctx context.Context, in *CreateDaemonSetRequest, opts ...client.CallOption) (*CreateDaemonSetResponse, error) {
	req := c.c.NewRequest(c.name, "DaemonSetService.CreateDaemonSet", in)
	out := new(CreateDaemonSetResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *daemonSetService) DeleteDaemonSet(ctx context.Context, in *DeleteDaemonSetRequest, opts ...client.CallOption) (*DeleteDaemonSetResponse, error) {
	req := c.c.NewRequest(c.name, "DaemonSetService.DeleteDaemonSet", in)
	out := new(DeleteDaemonSetResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// Server API for DaemonSetService service

type DaemonSetServiceHandler interface {
	GetDaemonSetList(context.Context, *GetDaemonSetListRequest, *GetDaemonSetListResponse) error
	GetDaemonSet(context.Context, *GetDaemonSetRequest, *GetDaemonSetResponse) error
	UpdateDaemonSet(context.Context, *UpdateDaemonSetRequest, *UpdateDaemonSetResponse) error
	CreateDaemonSet(context.Context, *CreateDaemonSetRequest, *CreateDaemonSetResponse) error
	DeleteDaemonSet(context.Context, *DeleteDaemonSetRequest, *DeleteDaemonSetResponse) error
}

func RegisterDaemonSetServiceHandler(s server.Server, hdlr DaemonSetServiceHandler, opts ...server.HandlerOption) error {
	type daemonSetService interface {
		GetDaemonSetList(ctx context.Context, in *GetDaemonSetListRequest, out *GetDaemonSetListResponse) error
		GetDaemonSet(ctx context.Context, in *GetDaemonSetRequest, out *GetDaemonSetResponse) error
		UpdateDaemonSet(ctx context.Context, in *UpdateDaemonSetRequest, out *UpdateDaemonSetResponse) error
		CreateDaemonSet(ctx context.Context, in *CreateDaemonSetRequest, out *CreateDaemonSetResponse) error
		DeleteDaemonSet(ctx context.Context, in *DeleteDaemonSetRequest, out *DeleteDaemonSetResponse) error
	}
	type DaemonSetService struct {
		daemonSetService
	}
	h := &daemonSetServiceHandler{hdlr}
	return s.Handle(s.NewHandler(&DaemonSetService{h}, opts...))
}

type daemonSetServiceHandler struct {
	DaemonSetServiceHandler
}

func (h *daemonSetServiceHandler) GetDaemonSetList(ctx context.Context, in *GetDaemonSetListRequest, out *GetDaemonSetListResponse) error {
	return h.DaemonSetServiceHandler.GetDaemonSetList(ctx, in, out)
}

func (h *daemonSetServiceHandler) GetDaemonSet(ctx context.Context, in *GetDaemonSetRequest, out *GetDaemonSetResponse) error {
	return h.DaemonSetServiceHandler.GetDaemonSet(ctx, in, out)
}

func (h *daemonSetServiceHandler) UpdateDaemonSet(ctx context.Context, in *UpdateDaemonSetRequest, out *UpdateDaemonSetResponse) error {
	return h.DaemonSetServiceHandler.UpdateDaemonSet(ctx, in, out)
}

func (h *daemonSetServiceHandler) CreateDaemonSet(ctx context.Context, in *CreateDaemonSetRequest, out *CreateDaemonSetResponse) error {
	return h.DaemonSetServiceHandler.CreateDaemonSet(ctx, in, out)
}

func (h *daemonSetServiceHandler) DeleteDaemonSet(ctx context.Context, in *DeleteDaemonSetRequest, out *DeleteDaemonSetResponse) error {
	return h.DaemonSetServiceHandler.DeleteDaemonSet(ctx, in, out)
}
