// Code generated by protoc-gen-micro. DO NOT EDIT.
// source: proto/deployment.proto

package kubernetes_service

import (
	fmt "fmt"
	proto "google.golang.org/protobuf/proto"
	math "math"
)

import (
	context "context"
	api "go-micro.dev/v4/api"
	client "go-micro.dev/v4/client"
	server "go-micro.dev/v4/server"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// Reference imports to suppress errors if they are not otherwise used.
var _ api.Endpoint
var _ context.Context
var _ client.Option
var _ server.Option

// Api Endpoints for DeploymentService service

func NewDeploymentServiceEndpoints() []*api.Endpoint {
	return []*api.Endpoint{}
}

// Client API for DeploymentService service

type DeploymentService interface {
	GetDeploymentList(ctx context.Context, in *GetDeploymentListRequest, opts ...client.CallOption) (*GetDeploymentListResponse, error)
	GetDeployment(ctx context.Context, in *GetDeploymentRequest, opts ...client.CallOption) (*GetDeploymentResponse, error)
	UpdateDeployment(ctx context.Context, in *UpdateDeploymentRequest, opts ...client.CallOption) (*UpdateDeploymentResponse, error)
	CreateDeployment(ctx context.Context, in *CreateDeploymentRequest, opts ...client.CallOption) (*CreateDeploymentResponse, error)
	DeleteDeployment(ctx context.Context, in *DeleteDeploymentRequest, opts ...client.CallOption) (*DeleteDeploymentResponse, error)
}

type deploymentService struct {
	c    client.Client
	name string
}

func NewDeploymentService(name string, c client.Client) DeploymentService {
	return &deploymentService{
		c:    c,
		name: name,
	}
}

func (c *deploymentService) GetDeploymentList(ctx context.Context, in *GetDeploymentListRequest, opts ...client.CallOption) (*GetDeploymentListResponse, error) {
	req := c.c.NewRequest(c.name, "DeploymentService.GetDeploymentList", in)
	out := new(GetDeploymentListResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *deploymentService) GetDeployment(ctx context.Context, in *GetDeploymentRequest, opts ...client.CallOption) (*GetDeploymentResponse, error) {
	req := c.c.NewRequest(c.name, "DeploymentService.GetDeployment", in)
	out := new(GetDeploymentResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *deploymentService) UpdateDeployment(ctx context.Context, in *UpdateDeploymentRequest, opts ...client.CallOption) (*UpdateDeploymentResponse, error) {
	req := c.c.NewRequest(c.name, "DeploymentService.UpdateDeployment", in)
	out := new(UpdateDeploymentResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *deploymentService) CreateDeployment(ctx context.Context, in *CreateDeploymentRequest, opts ...client.CallOption) (*CreateDeploymentResponse, error) {
	req := c.c.NewRequest(c.name, "DeploymentService.CreateDeployment", in)
	out := new(CreateDeploymentResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *deploymentService) DeleteDeployment(ctx context.Context, in *DeleteDeploymentRequest, opts ...client.CallOption) (*DeleteDeploymentResponse, error) {
	req := c.c.NewRequest(c.name, "DeploymentService.DeleteDeployment", in)
	out := new(DeleteDeploymentResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// Server API for DeploymentService service

type DeploymentServiceHandler interface {
	GetDeploymentList(context.Context, *GetDeploymentListRequest, *GetDeploymentListResponse) error
	GetDeployment(context.Context, *GetDeploymentRequest, *GetDeploymentResponse) error
	UpdateDeployment(context.Context, *UpdateDeploymentRequest, *UpdateDeploymentResponse) error
	CreateDeployment(context.Context, *CreateDeploymentRequest, *CreateDeploymentResponse) error
	DeleteDeployment(context.Context, *DeleteDeploymentRequest, *DeleteDeploymentResponse) error
}

func RegisterDeploymentServiceHandler(s server.Server, hdlr DeploymentServiceHandler, opts ...server.HandlerOption) error {
	type deploymentService interface {
		GetDeploymentList(ctx context.Context, in *GetDeploymentListRequest, out *GetDeploymentListResponse) error
		GetDeployment(ctx context.Context, in *GetDeploymentRequest, out *GetDeploymentResponse) error
		UpdateDeployment(ctx context.Context, in *UpdateDeploymentRequest, out *UpdateDeploymentResponse) error
		CreateDeployment(ctx context.Context, in *CreateDeploymentRequest, out *CreateDeploymentResponse) error
		DeleteDeployment(ctx context.Context, in *DeleteDeploymentRequest, out *DeleteDeploymentResponse) error
	}
	type DeploymentService struct {
		deploymentService
	}
	h := &deploymentServiceHandler{hdlr}
	return s.Handle(s.NewHandler(&DeploymentService{h}, opts...))
}

type deploymentServiceHandler struct {
	DeploymentServiceHandler
}

func (h *deploymentServiceHandler) GetDeploymentList(ctx context.Context, in *GetDeploymentListRequest, out *GetDeploymentListResponse) error {
	return h.DeploymentServiceHandler.GetDeploymentList(ctx, in, out)
}

func (h *deploymentServiceHandler) GetDeployment(ctx context.Context, in *GetDeploymentRequest, out *GetDeploymentResponse) error {
	return h.DeploymentServiceHandler.GetDeployment(ctx, in, out)
}

func (h *deploymentServiceHandler) UpdateDeployment(ctx context.Context, in *UpdateDeploymentRequest, out *UpdateDeploymentResponse) error {
	return h.DeploymentServiceHandler.UpdateDeployment(ctx, in, out)
}

func (h *deploymentServiceHandler) CreateDeployment(ctx context.Context, in *CreateDeploymentRequest, out *CreateDeploymentResponse) error {
	return h.DeploymentServiceHandler.CreateDeployment(ctx, in, out)
}

func (h *deploymentServiceHandler) DeleteDeployment(ctx context.Context, in *DeleteDeploymentRequest, out *DeleteDeploymentResponse) error {
	return h.DeploymentServiceHandler.DeleteDeployment(ctx, in, out)
}
