// Code generated by protoc-gen-micro. DO NOT EDIT.
// source: proto/ingress.proto

package kubernetes_service

import (
	fmt "fmt"
	proto "google.golang.org/protobuf/proto"
	math "math"
)

import (
	context "context"
	api "go-micro.dev/v4/api"
	client "go-micro.dev/v4/client"
	server "go-micro.dev/v4/server"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// Reference imports to suppress errors if they are not otherwise used.
var _ api.Endpoint
var _ context.Context
var _ client.Option
var _ server.Option

// Api Endpoints for IngressService service

func NewIngressServiceEndpoints() []*api.Endpoint {
	return []*api.Endpoint{}
}

// Client API for IngressService service

type IngressService interface {
	GetIngressList(ctx context.Context, in *GetIngressListRequest, opts ...client.CallOption) (*GetIngressListResponse, error)
	GetIngress(ctx context.Context, in *GetIngressRequest, opts ...client.CallOption) (*GetIngressResponse, error)
	UpdateIngress(ctx context.Context, in *UpdateIngressRequest, opts ...client.CallOption) (*UpdateIngressResponse, error)
	CreateIngress(ctx context.Context, in *CreateIngressRequest, opts ...client.CallOption) (*CreateIngressResponse, error)
	DeleteIngress(ctx context.Context, in *DeleteIngressRequest, opts ...client.CallOption) (*DeleteIngressResponse, error)
}

type ingressService struct {
	c    client.Client
	name string
}

func NewIngressService(name string, c client.Client) IngressService {
	return &ingressService{
		c:    c,
		name: name,
	}
}

func (c *ingressService) GetIngressList(ctx context.Context, in *GetIngressListRequest, opts ...client.CallOption) (*GetIngressListResponse, error) {
	req := c.c.NewRequest(c.name, "IngressService.GetIngressList", in)
	out := new(GetIngressListResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *ingressService) GetIngress(ctx context.Context, in *GetIngressRequest, opts ...client.CallOption) (*GetIngressResponse, error) {
	req := c.c.NewRequest(c.name, "IngressService.GetIngress", in)
	out := new(GetIngressResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *ingressService) UpdateIngress(ctx context.Context, in *UpdateIngressRequest, opts ...client.CallOption) (*UpdateIngressResponse, error) {
	req := c.c.NewRequest(c.name, "IngressService.UpdateIngress", in)
	out := new(UpdateIngressResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *ingressService) CreateIngress(ctx context.Context, in *CreateIngressRequest, opts ...client.CallOption) (*CreateIngressResponse, error) {
	req := c.c.NewRequest(c.name, "IngressService.CreateIngress", in)
	out := new(CreateIngressResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *ingressService) DeleteIngress(ctx context.Context, in *DeleteIngressRequest, opts ...client.CallOption) (*DeleteIngressResponse, error) {
	req := c.c.NewRequest(c.name, "IngressService.DeleteIngress", in)
	out := new(DeleteIngressResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// Server API for IngressService service

type IngressServiceHandler interface {
	GetIngressList(context.Context, *GetIngressListRequest, *GetIngressListResponse) error
	GetIngress(context.Context, *GetIngressRequest, *GetIngressResponse) error
	UpdateIngress(context.Context, *UpdateIngressRequest, *UpdateIngressResponse) error
	CreateIngress(context.Context, *CreateIngressRequest, *CreateIngressResponse) error
	DeleteIngress(context.Context, *DeleteIngressRequest, *DeleteIngressResponse) error
}

func RegisterIngressServiceHandler(s server.Server, hdlr IngressServiceHandler, opts ...server.HandlerOption) error {
	type ingressService interface {
		GetIngressList(ctx context.Context, in *GetIngressListRequest, out *GetIngressListResponse) error
		GetIngress(ctx context.Context, in *GetIngressRequest, out *GetIngressResponse) error
		UpdateIngress(ctx context.Context, in *UpdateIngressRequest, out *UpdateIngressResponse) error
		CreateIngress(ctx context.Context, in *CreateIngressRequest, out *CreateIngressResponse) error
		DeleteIngress(ctx context.Context, in *DeleteIngressRequest, out *DeleteIngressResponse) error
	}
	type IngressService struct {
		ingressService
	}
	h := &ingressServiceHandler{hdlr}
	return s.Handle(s.NewHandler(&IngressService{h}, opts...))
}

type ingressServiceHandler struct {
	IngressServiceHandler
}

func (h *ingressServiceHandler) GetIngressList(ctx context.Context, in *GetIngressListRequest, out *GetIngressListResponse) error {
	return h.IngressServiceHandler.GetIngressList(ctx, in, out)
}

func (h *ingressServiceHandler) GetIngress(ctx context.Context, in *GetIngressRequest, out *GetIngressResponse) error {
	return h.IngressServiceHandler.GetIngress(ctx, in, out)
}

func (h *ingressServiceHandler) UpdateIngress(ctx context.Context, in *UpdateIngressRequest, out *UpdateIngressResponse) error {
	return h.IngressServiceHandler.UpdateIngress(ctx, in, out)
}

func (h *ingressServiceHandler) CreateIngress(ctx context.Context, in *CreateIngressRequest, out *CreateIngressResponse) error {
	return h.IngressServiceHandler.CreateIngress(ctx, in, out)
}

func (h *ingressServiceHandler) DeleteIngress(ctx context.Context, in *DeleteIngressRequest, out *DeleteIngressResponse) error {
	return h.IngressServiceHandler.DeleteIngress(ctx, in, out)
}
