// Code generated by protoc-gen-micro. DO NOT EDIT.
// source: proto/ingressroute.proto

package kubernetes_service

import (
	fmt "fmt"
	proto "google.golang.org/protobuf/proto"
	math "math"
)

import (
	context "context"
	api "go-micro.dev/v4/api"
	client "go-micro.dev/v4/client"
	server "go-micro.dev/v4/server"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// Reference imports to suppress errors if they are not otherwise used.
var _ api.Endpoint
var _ context.Context
var _ client.Option
var _ server.Option

// Api Endpoints for IngressRouteService service

func NewIngressRouteServiceEndpoints() []*api.Endpoint {
	return []*api.Endpoint{}
}

// Client API for IngressRouteService service

type IngressRouteService interface {
	GetIngressRouteList(ctx context.Context, in *GetIngressRouteListRequest, opts ...client.CallOption) (*GetIngressRouteListResponse, error)
	GetIngressRoute(ctx context.Context, in *GetIngressRouteRequest, opts ...client.CallOption) (*GetIngressRouteResponse, error)
	UpdateIngressRoute(ctx context.Context, in *UpdateIngressRouteRequest, opts ...client.CallOption) (*UpdateIngressRouteResponse, error)
	CreateIngressRoute(ctx context.Context, in *CreateIngressRouteRequest, opts ...client.CallOption) (*CreateIngressRouteResponse, error)
	DeleteIngressRoute(ctx context.Context, in *DeleteIngressRouteRequest, opts ...client.CallOption) (*DeleteIngressRouteResponse, error)
}

type ingressRouteService struct {
	c    client.Client
	name string
}

func NewIngressRouteService(name string, c client.Client) IngressRouteService {
	return &ingressRouteService{
		c:    c,
		name: name,
	}
}

func (c *ingressRouteService) GetIngressRouteList(ctx context.Context, in *GetIngressRouteListRequest, opts ...client.CallOption) (*GetIngressRouteListResponse, error) {
	req := c.c.NewRequest(c.name, "IngressRouteService.GetIngressRouteList", in)
	out := new(GetIngressRouteListResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *ingressRouteService) GetIngressRoute(ctx context.Context, in *GetIngressRouteRequest, opts ...client.CallOption) (*GetIngressRouteResponse, error) {
	req := c.c.NewRequest(c.name, "IngressRouteService.GetIngressRoute", in)
	out := new(GetIngressRouteResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *ingressRouteService) UpdateIngressRoute(ctx context.Context, in *UpdateIngressRouteRequest, opts ...client.CallOption) (*UpdateIngressRouteResponse, error) {
	req := c.c.NewRequest(c.name, "IngressRouteService.UpdateIngressRoute", in)
	out := new(UpdateIngressRouteResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *ingressRouteService) CreateIngressRoute(ctx context.Context, in *CreateIngressRouteRequest, opts ...client.CallOption) (*CreateIngressRouteResponse, error) {
	req := c.c.NewRequest(c.name, "IngressRouteService.CreateIngressRoute", in)
	out := new(CreateIngressRouteResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *ingressRouteService) DeleteIngressRoute(ctx context.Context, in *DeleteIngressRouteRequest, opts ...client.CallOption) (*DeleteIngressRouteResponse, error) {
	req := c.c.NewRequest(c.name, "IngressRouteService.DeleteIngressRoute", in)
	out := new(DeleteIngressRouteResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// Server API for IngressRouteService service

type IngressRouteServiceHandler interface {
	GetIngressRouteList(context.Context, *GetIngressRouteListRequest, *GetIngressRouteListResponse) error
	GetIngressRoute(context.Context, *GetIngressRouteRequest, *GetIngressRouteResponse) error
	UpdateIngressRoute(context.Context, *UpdateIngressRouteRequest, *UpdateIngressRouteResponse) error
	CreateIngressRoute(context.Context, *CreateIngressRouteRequest, *CreateIngressRouteResponse) error
	DeleteIngressRoute(context.Context, *DeleteIngressRouteRequest, *DeleteIngressRouteResponse) error
}

func RegisterIngressRouteServiceHandler(s server.Server, hdlr IngressRouteServiceHandler, opts ...server.HandlerOption) error {
	type ingressRouteService interface {
		GetIngressRouteList(ctx context.Context, in *GetIngressRouteListRequest, out *GetIngressRouteListResponse) error
		GetIngressRoute(ctx context.Context, in *GetIngressRouteRequest, out *GetIngressRouteResponse) error
		UpdateIngressRoute(ctx context.Context, in *UpdateIngressRouteRequest, out *UpdateIngressRouteResponse) error
		CreateIngressRoute(ctx context.Context, in *CreateIngressRouteRequest, out *CreateIngressRouteResponse) error
		DeleteIngressRoute(ctx context.Context, in *DeleteIngressRouteRequest, out *DeleteIngressRouteResponse) error
	}
	type IngressRouteService struct {
		ingressRouteService
	}
	h := &ingressRouteServiceHandler{hdlr}
	return s.Handle(s.NewHandler(&IngressRouteService{h}, opts...))
}

type ingressRouteServiceHandler struct {
	IngressRouteServiceHandler
}

func (h *ingressRouteServiceHandler) GetIngressRouteList(ctx context.Context, in *GetIngressRouteListRequest, out *GetIngressRouteListResponse) error {
	return h.IngressRouteServiceHandler.GetIngressRouteList(ctx, in, out)
}

func (h *ingressRouteServiceHandler) GetIngressRoute(ctx context.Context, in *GetIngressRouteRequest, out *GetIngressRouteResponse) error {
	return h.IngressRouteServiceHandler.GetIngressRoute(ctx, in, out)
}

func (h *ingressRouteServiceHandler) UpdateIngressRoute(ctx context.Context, in *UpdateIngressRouteRequest, out *UpdateIngressRouteResponse) error {
	return h.IngressRouteServiceHandler.UpdateIngressRoute(ctx, in, out)
}

func (h *ingressRouteServiceHandler) CreateIngressRoute(ctx context.Context, in *CreateIngressRouteRequest, out *CreateIngressRouteResponse) error {
	return h.IngressRouteServiceHandler.CreateIngressRoute(ctx, in, out)
}

func (h *ingressRouteServiceHandler) DeleteIngressRoute(ctx context.Context, in *DeleteIngressRouteRequest, out *DeleteIngressRouteResponse) error {
	return h.IngressRouteServiceHandler.DeleteIngressRoute(ctx, in, out)
}
