// Code generated by protoc-gen-micro. DO NOT EDIT.
// source: proto/middleware.proto

package kubernetes_service

import (
	fmt "fmt"
	proto "google.golang.org/protobuf/proto"
	math "math"
)

import (
	context "context"
	api "go-micro.dev/v4/api"
	client "go-micro.dev/v4/client"
	server "go-micro.dev/v4/server"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// Reference imports to suppress errors if they are not otherwise used.
var _ api.Endpoint
var _ context.Context
var _ client.Option
var _ server.Option

// Api Endpoints for MiddlewareService service

func NewMiddlewareServiceEndpoints() []*api.Endpoint {
	return []*api.Endpoint{}
}

// Client API for MiddlewareService service

type MiddlewareService interface {
	GetMiddlewareList(ctx context.Context, in *GetMiddlewareListRequest, opts ...client.CallOption) (*GetMiddlewareListResponse, error)
	GetMiddleware(ctx context.Context, in *GetMiddlewareRequest, opts ...client.CallOption) (*GetMiddlewareResponse, error)
	UpdateMiddleware(ctx context.Context, in *UpdateMiddlewareRequest, opts ...client.CallOption) (*UpdateMiddlewareResponse, error)
	CreateMiddleware(ctx context.Context, in *CreateMiddlewareRequest, opts ...client.CallOption) (*CreateMiddlewareResponse, error)
	DeleteMiddleware(ctx context.Context, in *DeleteMiddlewareRequest, opts ...client.CallOption) (*DeleteMiddlewareResponse, error)
}

type middlewareService struct {
	c    client.Client
	name string
}

func NewMiddlewareService(name string, c client.Client) MiddlewareService {
	return &middlewareService{
		c:    c,
		name: name,
	}
}

func (c *middlewareService) GetMiddlewareList(ctx context.Context, in *GetMiddlewareListRequest, opts ...client.CallOption) (*GetMiddlewareListResponse, error) {
	req := c.c.NewRequest(c.name, "MiddlewareService.GetMiddlewareList", in)
	out := new(GetMiddlewareListResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *middlewareService) GetMiddleware(ctx context.Context, in *GetMiddlewareRequest, opts ...client.CallOption) (*GetMiddlewareResponse, error) {
	req := c.c.NewRequest(c.name, "MiddlewareService.GetMiddleware", in)
	out := new(GetMiddlewareResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *middlewareService) UpdateMiddleware(ctx context.Context, in *UpdateMiddlewareRequest, opts ...client.CallOption) (*UpdateMiddlewareResponse, error) {
	req := c.c.NewRequest(c.name, "MiddlewareService.UpdateMiddleware", in)
	out := new(UpdateMiddlewareResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *middlewareService) CreateMiddleware(ctx context.Context, in *CreateMiddlewareRequest, opts ...client.CallOption) (*CreateMiddlewareResponse, error) {
	req := c.c.NewRequest(c.name, "MiddlewareService.CreateMiddleware", in)
	out := new(CreateMiddlewareResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *middlewareService) DeleteMiddleware(ctx context.Context, in *DeleteMiddlewareRequest, opts ...client.CallOption) (*DeleteMiddlewareResponse, error) {
	req := c.c.NewRequest(c.name, "MiddlewareService.DeleteMiddleware", in)
	out := new(DeleteMiddlewareResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// Server API for MiddlewareService service

type MiddlewareServiceHandler interface {
	GetMiddlewareList(context.Context, *GetMiddlewareListRequest, *GetMiddlewareListResponse) error
	GetMiddleware(context.Context, *GetMiddlewareRequest, *GetMiddlewareResponse) error
	UpdateMiddleware(context.Context, *UpdateMiddlewareRequest, *UpdateMiddlewareResponse) error
	CreateMiddleware(context.Context, *CreateMiddlewareRequest, *CreateMiddlewareResponse) error
	DeleteMiddleware(context.Context, *DeleteMiddlewareRequest, *DeleteMiddlewareResponse) error
}

func RegisterMiddlewareServiceHandler(s server.Server, hdlr MiddlewareServiceHandler, opts ...server.HandlerOption) error {
	type middlewareService interface {
		GetMiddlewareList(ctx context.Context, in *GetMiddlewareListRequest, out *GetMiddlewareListResponse) error
		GetMiddleware(ctx context.Context, in *GetMiddlewareRequest, out *GetMiddlewareResponse) error
		UpdateMiddleware(ctx context.Context, in *UpdateMiddlewareRequest, out *UpdateMiddlewareResponse) error
		CreateMiddleware(ctx context.Context, in *CreateMiddlewareRequest, out *CreateMiddlewareResponse) error
		DeleteMiddleware(ctx context.Context, in *DeleteMiddlewareRequest, out *DeleteMiddlewareResponse) error
	}
	type MiddlewareService struct {
		middlewareService
	}
	h := &middlewareServiceHandler{hdlr}
	return s.Handle(s.NewHandler(&MiddlewareService{h}, opts...))
}

type middlewareServiceHandler struct {
	MiddlewareServiceHandler
}

func (h *middlewareServiceHandler) GetMiddlewareList(ctx context.Context, in *GetMiddlewareListRequest, out *GetMiddlewareListResponse) error {
	return h.MiddlewareServiceHandler.GetMiddlewareList(ctx, in, out)
}

func (h *middlewareServiceHandler) GetMiddleware(ctx context.Context, in *GetMiddlewareRequest, out *GetMiddlewareResponse) error {
	return h.MiddlewareServiceHandler.GetMiddleware(ctx, in, out)
}

func (h *middlewareServiceHandler) UpdateMiddleware(ctx context.Context, in *UpdateMiddlewareRequest, out *UpdateMiddlewareResponse) error {
	return h.MiddlewareServiceHandler.UpdateMiddleware(ctx, in, out)
}

func (h *middlewareServiceHandler) CreateMiddleware(ctx context.Context, in *CreateMiddlewareRequest, out *CreateMiddlewareResponse) error {
	return h.MiddlewareServiceHandler.CreateMiddleware(ctx, in, out)
}

func (h *middlewareServiceHandler) DeleteMiddleware(ctx context.Context, in *DeleteMiddlewareRequest, out *DeleteMiddlewareResponse) error {
	return h.MiddlewareServiceHandler.DeleteMiddleware(ctx, in, out)
}
