// Code generated by protoc-gen-micro. DO NOT EDIT.
// source: proto/pod.proto

package kubernetes_service

import (
	fmt "fmt"
	proto "google.golang.org/protobuf/proto"
	math "math"
)

import (
	context "context"
	api "go-micro.dev/v4/api"
	client "go-micro.dev/v4/client"
	server "go-micro.dev/v4/server"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// Reference imports to suppress errors if they are not otherwise used.
var _ api.Endpoint
var _ context.Context
var _ client.Option
var _ server.Option

// Api Endpoints for PodService service

func NewPodServiceEndpoints() []*api.Endpoint {
	return []*api.Endpoint{}
}

// Client API for PodService service

type PodService interface {
	GetPodList(ctx context.Context, in *GetPodListRequest, opts ...client.CallOption) (*GetPodListResponse, error)
	GetPod(ctx context.Context, in *GetPodRequest, opts ...client.CallOption) (*GetPodResponse, error)
	UpdatePod(ctx context.Context, in *UpdatePodRequest, opts ...client.CallOption) (*UpdatePodResponse, error)
	CreatePod(ctx context.Context, in *CreatePodRequest, opts ...client.CallOption) (*CreatePodResponse, error)
	DeletePod(ctx context.Context, in *DeletePodRequest, opts ...client.CallOption) (*DeletePodResponse, error)
}

type podService struct {
	c    client.Client
	name string
}

func NewPodService(name string, c client.Client) PodService {
	return &podService{
		c:    c,
		name: name,
	}
}

func (c *podService) GetPodList(ctx context.Context, in *GetPodListRequest, opts ...client.CallOption) (*GetPodListResponse, error) {
	req := c.c.NewRequest(c.name, "PodService.GetPodList", in)
	out := new(GetPodListResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *podService) GetPod(ctx context.Context, in *GetPodRequest, opts ...client.CallOption) (*GetPodResponse, error) {
	req := c.c.NewRequest(c.name, "PodService.GetPod", in)
	out := new(GetPodResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *podService) UpdatePod(ctx context.Context, in *UpdatePodRequest, opts ...client.CallOption) (*UpdatePodResponse, error) {
	req := c.c.NewRequest(c.name, "PodService.UpdatePod", in)
	out := new(UpdatePodResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *podService) CreatePod(ctx context.Context, in *CreatePodRequest, opts ...client.CallOption) (*CreatePodResponse, error) {
	req := c.c.NewRequest(c.name, "PodService.CreatePod", in)
	out := new(CreatePodResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *podService) DeletePod(ctx context.Context, in *DeletePodRequest, opts ...client.CallOption) (*DeletePodResponse, error) {
	req := c.c.NewRequest(c.name, "PodService.DeletePod", in)
	out := new(DeletePodResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// Server API for PodService service

type PodServiceHandler interface {
	GetPodList(context.Context, *GetPodListRequest, *GetPodListResponse) error
	GetPod(context.Context, *GetPodRequest, *GetPodResponse) error
	UpdatePod(context.Context, *UpdatePodRequest, *UpdatePodResponse) error
	CreatePod(context.Context, *CreatePodRequest, *CreatePodResponse) error
	DeletePod(context.Context, *DeletePodRequest, *DeletePodResponse) error
}

func RegisterPodServiceHandler(s server.Server, hdlr PodServiceHandler, opts ...server.HandlerOption) error {
	type podService interface {
		GetPodList(ctx context.Context, in *GetPodListRequest, out *GetPodListResponse) error
		GetPod(ctx context.Context, in *GetPodRequest, out *GetPodResponse) error
		UpdatePod(ctx context.Context, in *UpdatePodRequest, out *UpdatePodResponse) error
		CreatePod(ctx context.Context, in *CreatePodRequest, out *CreatePodResponse) error
		DeletePod(ctx context.Context, in *DeletePodRequest, out *DeletePodResponse) error
	}
	type PodService struct {
		podService
	}
	h := &podServiceHandler{hdlr}
	return s.Handle(s.NewHandler(&PodService{h}, opts...))
}

type podServiceHandler struct {
	PodServiceHandler
}

func (h *podServiceHandler) GetPodList(ctx context.Context, in *GetPodListRequest, out *GetPodListResponse) error {
	return h.PodServiceHandler.GetPodList(ctx, in, out)
}

func (h *podServiceHandler) GetPod(ctx context.Context, in *GetPodRequest, out *GetPodResponse) error {
	return h.PodServiceHandler.GetPod(ctx, in, out)
}

func (h *podServiceHandler) UpdatePod(ctx context.Context, in *UpdatePodRequest, out *UpdatePodResponse) error {
	return h.PodServiceHandler.UpdatePod(ctx, in, out)
}

func (h *podServiceHandler) CreatePod(ctx context.Context, in *CreatePodRequest, out *CreatePodResponse) error {
	return h.PodServiceHandler.CreatePod(ctx, in, out)
}

func (h *podServiceHandler) DeletePod(ctx context.Context, in *DeletePodRequest, out *DeletePodResponse) error {
	return h.PodServiceHandler.DeletePod(ctx, in, out)
}
