// Code generated by protoc-gen-micro. DO NOT EDIT.
// source: proto/secret.proto

package kubernetes_service

import (
	fmt "fmt"
	proto "google.golang.org/protobuf/proto"
	math "math"
)

import (
	context "context"
	api "go-micro.dev/v4/api"
	client "go-micro.dev/v4/client"
	server "go-micro.dev/v4/server"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// Reference imports to suppress errors if they are not otherwise used.
var _ api.Endpoint
var _ context.Context
var _ client.Option
var _ server.Option

// Api Endpoints for SecretService service

func NewSecretServiceEndpoints() []*api.Endpoint {
	return []*api.Endpoint{}
}

// Client API for SecretService service

type SecretService interface {
	GetSecretList(ctx context.Context, in *GetSecretListRequest, opts ...client.CallOption) (*GetSecretListResponse, error)
	GetSecret(ctx context.Context, in *GetSecretRequest, opts ...client.CallOption) (*GetSecretResponse, error)
	UpdateSecret(ctx context.Context, in *UpdateSecretRequest, opts ...client.CallOption) (*UpdateSecretResponse, error)
	CreateSecret(ctx context.Context, in *CreateSecretRequest, opts ...client.CallOption) (*CreateSecretResponse, error)
	DeleteSecret(ctx context.Context, in *DeleteSecretRequest, opts ...client.CallOption) (*DeleteSecretResponse, error)
}

type secretService struct {
	c    client.Client
	name string
}

func NewSecretService(name string, c client.Client) SecretService {
	return &secretService{
		c:    c,
		name: name,
	}
}

func (c *secretService) GetSecretList(ctx context.Context, in *GetSecretListRequest, opts ...client.CallOption) (*GetSecretListResponse, error) {
	req := c.c.NewRequest(c.name, "SecretService.GetSecretList", in)
	out := new(GetSecretListResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *secretService) GetSecret(ctx context.Context, in *GetSecretRequest, opts ...client.CallOption) (*GetSecretResponse, error) {
	req := c.c.NewRequest(c.name, "SecretService.GetSecret", in)
	out := new(GetSecretResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *secretService) UpdateSecret(ctx context.Context, in *UpdateSecretRequest, opts ...client.CallOption) (*UpdateSecretResponse, error) {
	req := c.c.NewRequest(c.name, "SecretService.UpdateSecret", in)
	out := new(UpdateSecretResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *secretService) CreateSecret(ctx context.Context, in *CreateSecretRequest, opts ...client.CallOption) (*CreateSecretResponse, error) {
	req := c.c.NewRequest(c.name, "SecretService.CreateSecret", in)
	out := new(CreateSecretResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *secretService) DeleteSecret(ctx context.Context, in *DeleteSecretRequest, opts ...client.CallOption) (*DeleteSecretResponse, error) {
	req := c.c.NewRequest(c.name, "SecretService.DeleteSecret", in)
	out := new(DeleteSecretResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// Server API for SecretService service

type SecretServiceHandler interface {
	GetSecretList(context.Context, *GetSecretListRequest, *GetSecretListResponse) error
	GetSecret(context.Context, *GetSecretRequest, *GetSecretResponse) error
	UpdateSecret(context.Context, *UpdateSecretRequest, *UpdateSecretResponse) error
	CreateSecret(context.Context, *CreateSecretRequest, *CreateSecretResponse) error
	DeleteSecret(context.Context, *DeleteSecretRequest, *DeleteSecretResponse) error
}

func RegisterSecretServiceHandler(s server.Server, hdlr SecretServiceHandler, opts ...server.HandlerOption) error {
	type secretService interface {
		GetSecretList(ctx context.Context, in *GetSecretListRequest, out *GetSecretListResponse) error
		GetSecret(ctx context.Context, in *GetSecretRequest, out *GetSecretResponse) error
		UpdateSecret(ctx context.Context, in *UpdateSecretRequest, out *UpdateSecretResponse) error
		CreateSecret(ctx context.Context, in *CreateSecretRequest, out *CreateSecretResponse) error
		DeleteSecret(ctx context.Context, in *DeleteSecretRequest, out *DeleteSecretResponse) error
	}
	type SecretService struct {
		secretService
	}
	h := &secretServiceHandler{hdlr}
	return s.Handle(s.NewHandler(&SecretService{h}, opts...))
}

type secretServiceHandler struct {
	SecretServiceHandler
}

func (h *secretServiceHandler) GetSecretList(ctx context.Context, in *GetSecretListRequest, out *GetSecretListResponse) error {
	return h.SecretServiceHandler.GetSecretList(ctx, in, out)
}

func (h *secretServiceHandler) GetSecret(ctx context.Context, in *GetSecretRequest, out *GetSecretResponse) error {
	return h.SecretServiceHandler.GetSecret(ctx, in, out)
}

func (h *secretServiceHandler) UpdateSecret(ctx context.Context, in *UpdateSecretRequest, out *UpdateSecretResponse) error {
	return h.SecretServiceHandler.UpdateSecret(ctx, in, out)
}

func (h *secretServiceHandler) CreateSecret(ctx context.Context, in *CreateSecretRequest, out *CreateSecretResponse) error {
	return h.SecretServiceHandler.CreateSecret(ctx, in, out)
}

func (h *secretServiceHandler) DeleteSecret(ctx context.Context, in *DeleteSecretRequest, out *DeleteSecretResponse) error {
	return h.SecretServiceHandler.DeleteSecret(ctx, in, out)
}
