// Code generated by protoc-gen-micro. DO NOT EDIT.
// source: proto/serviceaccount.proto

package kubernetes_service

import (
	fmt "fmt"
	proto "google.golang.org/protobuf/proto"
	math "math"
)

import (
	context "context"
	api "go-micro.dev/v4/api"
	client "go-micro.dev/v4/client"
	server "go-micro.dev/v4/server"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// Reference imports to suppress errors if they are not otherwise used.
var _ api.Endpoint
var _ context.Context
var _ client.Option
var _ server.Option

// Api Endpoints for ServiceAccountService service

func NewServiceAccountServiceEndpoints() []*api.Endpoint {
	return []*api.Endpoint{}
}

// Client API for ServiceAccountService service

type ServiceAccountService interface {
	GetServiceAccountList(ctx context.Context, in *GetServiceAccountListRequest, opts ...client.CallOption) (*GetServiceAccountListResponse, error)
	GetServiceAccount(ctx context.Context, in *GetServiceAccountRequest, opts ...client.CallOption) (*GetServiceAccountResponse, error)
	UpdateServiceAccount(ctx context.Context, in *UpdateServiceAccountRequest, opts ...client.CallOption) (*UpdateServiceAccountResponse, error)
	CreateServiceAccount(ctx context.Context, in *CreateServiceAccountRequest, opts ...client.CallOption) (*CreateServiceAccountResponse, error)
	DeleteServiceAccount(ctx context.Context, in *DeleteServiceAccountRequest, opts ...client.CallOption) (*DeleteServiceAccountResponse, error)
}

type serviceAccountService struct {
	c    client.Client
	name string
}

func NewServiceAccountService(name string, c client.Client) ServiceAccountService {
	return &serviceAccountService{
		c:    c,
		name: name,
	}
}

func (c *serviceAccountService) GetServiceAccountList(ctx context.Context, in *GetServiceAccountListRequest, opts ...client.CallOption) (*GetServiceAccountListResponse, error) {
	req := c.c.NewRequest(c.name, "ServiceAccountService.GetServiceAccountList", in)
	out := new(GetServiceAccountListResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *serviceAccountService) GetServiceAccount(ctx context.Context, in *GetServiceAccountRequest, opts ...client.CallOption) (*GetServiceAccountResponse, error) {
	req := c.c.NewRequest(c.name, "ServiceAccountService.GetServiceAccount", in)
	out := new(GetServiceAccountResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *serviceAccountService) UpdateServiceAccount(ctx context.Context, in *UpdateServiceAccountRequest, opts ...client.CallOption) (*UpdateServiceAccountResponse, error) {
	req := c.c.NewRequest(c.name, "ServiceAccountService.UpdateServiceAccount", in)
	out := new(UpdateServiceAccountResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *serviceAccountService) CreateServiceAccount(ctx context.Context, in *CreateServiceAccountRequest, opts ...client.CallOption) (*CreateServiceAccountResponse, error) {
	req := c.c.NewRequest(c.name, "ServiceAccountService.CreateServiceAccount", in)
	out := new(CreateServiceAccountResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *serviceAccountService) DeleteServiceAccount(ctx context.Context, in *DeleteServiceAccountRequest, opts ...client.CallOption) (*DeleteServiceAccountResponse, error) {
	req := c.c.NewRequest(c.name, "ServiceAccountService.DeleteServiceAccount", in)
	out := new(DeleteServiceAccountResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// Server API for ServiceAccountService service

type ServiceAccountServiceHandler interface {
	GetServiceAccountList(context.Context, *GetServiceAccountListRequest, *GetServiceAccountListResponse) error
	GetServiceAccount(context.Context, *GetServiceAccountRequest, *GetServiceAccountResponse) error
	UpdateServiceAccount(context.Context, *UpdateServiceAccountRequest, *UpdateServiceAccountResponse) error
	CreateServiceAccount(context.Context, *CreateServiceAccountRequest, *CreateServiceAccountResponse) error
	DeleteServiceAccount(context.Context, *DeleteServiceAccountRequest, *DeleteServiceAccountResponse) error
}

func RegisterServiceAccountServiceHandler(s server.Server, hdlr ServiceAccountServiceHandler, opts ...server.HandlerOption) error {
	type serviceAccountService interface {
		GetServiceAccountList(ctx context.Context, in *GetServiceAccountListRequest, out *GetServiceAccountListResponse) error
		GetServiceAccount(ctx context.Context, in *GetServiceAccountRequest, out *GetServiceAccountResponse) error
		UpdateServiceAccount(ctx context.Context, in *UpdateServiceAccountRequest, out *UpdateServiceAccountResponse) error
		CreateServiceAccount(ctx context.Context, in *CreateServiceAccountRequest, out *CreateServiceAccountResponse) error
		DeleteServiceAccount(ctx context.Context, in *DeleteServiceAccountRequest, out *DeleteServiceAccountResponse) error
	}
	type ServiceAccountService struct {
		serviceAccountService
	}
	h := &serviceAccountServiceHandler{hdlr}
	return s.Handle(s.NewHandler(&ServiceAccountService{h}, opts...))
}

type serviceAccountServiceHandler struct {
	ServiceAccountServiceHandler
}

func (h *serviceAccountServiceHandler) GetServiceAccountList(ctx context.Context, in *GetServiceAccountListRequest, out *GetServiceAccountListResponse) error {
	return h.ServiceAccountServiceHandler.GetServiceAccountList(ctx, in, out)
}

func (h *serviceAccountServiceHandler) GetServiceAccount(ctx context.Context, in *GetServiceAccountRequest, out *GetServiceAccountResponse) error {
	return h.ServiceAccountServiceHandler.GetServiceAccount(ctx, in, out)
}

func (h *serviceAccountServiceHandler) UpdateServiceAccount(ctx context.Context, in *UpdateServiceAccountRequest, out *UpdateServiceAccountResponse) error {
	return h.ServiceAccountServiceHandler.UpdateServiceAccount(ctx, in, out)
}

func (h *serviceAccountServiceHandler) CreateServiceAccount(ctx context.Context, in *CreateServiceAccountRequest, out *CreateServiceAccountResponse) error {
	return h.ServiceAccountServiceHandler.CreateServiceAccount(ctx, in, out)
}

func (h *serviceAccountServiceHandler) DeleteServiceAccount(ctx context.Context, in *DeleteServiceAccountRequest, out *DeleteServiceAccountResponse) error {
	return h.ServiceAccountServiceHandler.DeleteServiceAccount(ctx, in, out)
}
