// Code generated by protoc-gen-micro. DO NOT EDIT.
// source: proto/statefulset.proto

package kubernetes_service

import (
	fmt "fmt"
	proto "google.golang.org/protobuf/proto"
	math "math"
)

import (
	context "context"
	api "go-micro.dev/v4/api"
	client "go-micro.dev/v4/client"
	server "go-micro.dev/v4/server"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// Reference imports to suppress errors if they are not otherwise used.
var _ api.Endpoint
var _ context.Context
var _ client.Option
var _ server.Option

// Api Endpoints for StatefulSetService service

func NewStatefulSetServiceEndpoints() []*api.Endpoint {
	return []*api.Endpoint{}
}

// Client API for StatefulSetService service

type StatefulSetService interface {
	GetStatefulSetList(ctx context.Context, in *GetStatefulSetListRequest, opts ...client.CallOption) (*GetStatefulSetListResponse, error)
	GetStatefulSet(ctx context.Context, in *GetStatefulSetRequest, opts ...client.CallOption) (*GetStatefulSetResponse, error)
	UpdateStatefulSet(ctx context.Context, in *UpdateStatefulSetRequest, opts ...client.CallOption) (*UpdateStatefulSetResponse, error)
	CreateStatefulSet(ctx context.Context, in *CreateStatefulSetRequest, opts ...client.CallOption) (*CreateStatefulSetResponse, error)
	DeleteStatefulSet(ctx context.Context, in *DeleteStatefulSetRequest, opts ...client.CallOption) (*DeleteStatefulSetResponse, error)
}

type statefulSetService struct {
	c    client.Client
	name string
}

func NewStatefulSetService(name string, c client.Client) StatefulSetService {
	return &statefulSetService{
		c:    c,
		name: name,
	}
}

func (c *statefulSetService) GetStatefulSetList(ctx context.Context, in *GetStatefulSetListRequest, opts ...client.CallOption) (*GetStatefulSetListResponse, error) {
	req := c.c.NewRequest(c.name, "StatefulSetService.GetStatefulSetList", in)
	out := new(GetStatefulSetListResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *statefulSetService) GetStatefulSet(ctx context.Context, in *GetStatefulSetRequest, opts ...client.CallOption) (*GetStatefulSetResponse, error) {
	req := c.c.NewRequest(c.name, "StatefulSetService.GetStatefulSet", in)
	out := new(GetStatefulSetResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *statefulSetService) UpdateStatefulSet(ctx context.Context, in *UpdateStatefulSetRequest, opts ...client.CallOption) (*UpdateStatefulSetResponse, error) {
	req := c.c.NewRequest(c.name, "StatefulSetService.UpdateStatefulSet", in)
	out := new(UpdateStatefulSetResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *statefulSetService) CreateStatefulSet(ctx context.Context, in *CreateStatefulSetRequest, opts ...client.CallOption) (*CreateStatefulSetResponse, error) {
	req := c.c.NewRequest(c.name, "StatefulSetService.CreateStatefulSet", in)
	out := new(CreateStatefulSetResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *statefulSetService) DeleteStatefulSet(ctx context.Context, in *DeleteStatefulSetRequest, opts ...client.CallOption) (*DeleteStatefulSetResponse, error) {
	req := c.c.NewRequest(c.name, "StatefulSetService.DeleteStatefulSet", in)
	out := new(DeleteStatefulSetResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// Server API for StatefulSetService service

type StatefulSetServiceHandler interface {
	GetStatefulSetList(context.Context, *GetStatefulSetListRequest, *GetStatefulSetListResponse) error
	GetStatefulSet(context.Context, *GetStatefulSetRequest, *GetStatefulSetResponse) error
	UpdateStatefulSet(context.Context, *UpdateStatefulSetRequest, *UpdateStatefulSetResponse) error
	CreateStatefulSet(context.Context, *CreateStatefulSetRequest, *CreateStatefulSetResponse) error
	DeleteStatefulSet(context.Context, *DeleteStatefulSetRequest, *DeleteStatefulSetResponse) error
}

func RegisterStatefulSetServiceHandler(s server.Server, hdlr StatefulSetServiceHandler, opts ...server.HandlerOption) error {
	type statefulSetService interface {
		GetStatefulSetList(ctx context.Context, in *GetStatefulSetListRequest, out *GetStatefulSetListResponse) error
		GetStatefulSet(ctx context.Context, in *GetStatefulSetRequest, out *GetStatefulSetResponse) error
		UpdateStatefulSet(ctx context.Context, in *UpdateStatefulSetRequest, out *UpdateStatefulSetResponse) error
		CreateStatefulSet(ctx context.Context, in *CreateStatefulSetRequest, out *CreateStatefulSetResponse) error
		DeleteStatefulSet(ctx context.Context, in *DeleteStatefulSetRequest, out *DeleteStatefulSetResponse) error
	}
	type StatefulSetService struct {
		statefulSetService
	}
	h := &statefulSetServiceHandler{hdlr}
	return s.Handle(s.NewHandler(&StatefulSetService{h}, opts...))
}

type statefulSetServiceHandler struct {
	StatefulSetServiceHandler
}

func (h *statefulSetServiceHandler) GetStatefulSetList(ctx context.Context, in *GetStatefulSetListRequest, out *GetStatefulSetListResponse) error {
	return h.StatefulSetServiceHandler.GetStatefulSetList(ctx, in, out)
}

func (h *statefulSetServiceHandler) GetStatefulSet(ctx context.Context, in *GetStatefulSetRequest, out *GetStatefulSetResponse) error {
	return h.StatefulSetServiceHandler.GetStatefulSet(ctx, in, out)
}

func (h *statefulSetServiceHandler) UpdateStatefulSet(ctx context.Context, in *UpdateStatefulSetRequest, out *UpdateStatefulSetResponse) error {
	return h.StatefulSetServiceHandler.UpdateStatefulSet(ctx, in, out)
}

func (h *statefulSetServiceHandler) CreateStatefulSet(ctx context.Context, in *CreateStatefulSetRequest, out *CreateStatefulSetResponse) error {
	return h.StatefulSetServiceHandler.CreateStatefulSet(ctx, in, out)
}

func (h *statefulSetServiceHandler) DeleteStatefulSet(ctx context.Context, in *DeleteStatefulSetRequest, out *DeleteStatefulSetResponse) error {
	return h.StatefulSetServiceHandler.DeleteStatefulSet(ctx, in, out)
}
